// gradovi.c - Uređivanje imena gradova smeštenih u dinamičku matricu.

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAX_GRAD 100
#define MAX_DUZ  30

int main() {

  // Čitanje i obrada pojedinačnih imena:
  printf("\nNeuredjeni niz imena gradova:\n\n");
  char **gradovi = malloc(MAX_GRAD * sizeof(char *));
  int br_grad = 0;
  do {

    char *grad = malloc(MAX_DUZ);
    gets(grad);    // Čitanje sledećeg imena.

  // Kraj ako je dužina imena nula.
    int duz = strlen(grad);
  if (duz == 0) { free(grad); break; }

    grad = realloc(grad, duz+1);
    puts(grad);    // Ispisivanje pročitanog imena.

    // Uvrštavanje novog imena u uređeni niz starih imena.
    int i;
    for (i=br_grad-1; i>=0; i--)
      if (strcmp(gradovi[i], grad) > 0)
        gradovi[i+1] = gradovi[i];
      else break;
    gradovi[i+1] = grad;

    // Nastavak rada ako ima još slobodnih vrsta u matrici.
  } while (++br_grad < MAX_GRAD);
  gradovi = realloc(gradovi, 
              br_grad * sizeof(char *));

  // Ispisivanje uređenog niza imena:
  printf("\nUredjeni niz imena gradova:\n\n");
  for (int i=0; i<br_grad; i++) 
    puts(gradovi[i]);

  // Oslobađanje memorije:
  for (int i=0; i<br_grad; i++)
    free(gradovi[i]);
  free(gradovi);
}
