// din_niz.h - Deklaracije paketa funkcija za obradu dinamičkih nizova.

typedef struct { int *a, n; } Din_niz;      // Struktura dinamičkog niza.

Din_niz sastavi (int *a, int n); // Sastavljanje dinamičkog niza.
void    razlozi (Din_niz dn, int *a, int *n); // Razlaganje dinam. niza.
Din_niz kopiraj (Din_niz dn);    // Kopiranje dinamičkog niza.
void    obrni   (Din_niz dn);    // Obrtanje redosleda elemenata din. niza.
void    izostavi(Din_niz *dn, int k); // Izostavljanje elemenata din. niza.
Din_niz citaj   (void);          // Čitanje dinamičkog niza.
void    pisi    (Din_niz dn);    // Ispisivanje dinamičkog niza.
