// integral.c - Izračunavanje određenog integrala funkcije sin(x).

#include <stdio.h>
#include <math.h>

void pravoug(double(*)(double),double,double,double,double*,_Bool*);
void trapez (double(*)(double),double,double,double,double*,_Bool*);

#define PI 3.1415926535897932384626433832795

int main() {
  for (int i=0; i<=14; i++) {
    double eps = pow(10, -i), yprav, ytrap;
    _Bool uspprav, usptrap;
    pravoug(sin, 0, PI/2, eps, &yprav, &uspprav);
    trapez (sin, 0, PI/2, eps, &ytrap, &usptrap);
    printf("%9.2e %20.15f %3s %20.15f %3s\n",
           eps, yprav, (uspprav ? "da" : "ne"),
                ytrap, (usptrap ? "da" : "ne"));
  }
}
